HaskellForMaths-0.4.8: Combinatorics, group theory, commutative algebra, non-commutative algebra

Safe Haskell | None
Language | Haskell98

Math.Algebras.NonCommutative

Description

A module defining the algebra of non-commutative polynomials over a field k

# Documentation

data NonComMonomial v Source

Constructors

NCM Int [v] |

Instances

Monomial NonComMonomial Source |
(Eq k, Num k, Ord v) => Algebra k (NonComMonomial v) Source |
Eq v => Eq (NonComMonomial v) Source |
Ord v => Ord (NonComMonomial v) Source |
(Eq v, Show v) => Show (NonComMonomial v) Source |
Mon (NonComMonomial v) Source |
Eq v => DivisionBasis (NonComMonomial v) Source |

class Monomial m where Source

Methods

var :: v -> Vect Q (m v) Source

powers :: Eq v => m v -> [(v, Int)] Source

Instances

Monomial NonComMonomial Source |
Monomial SL2q Source |
Monomial M2q Source |
Monomial Aq02 Source |
Monomial Aq20 Source |

bind :: (Eq k, Eq v, Num k, Ord b, Show b, Algebra k b, Monomial m) => Vect k (m v) -> (v -> Vect k b) -> Vect k b Source

type NCPoly v = Vect Q (NonComMonomial v) Source

class DivisionBasis m where Source

Methods

divM :: m -> m -> Maybe (m, m) Source

Instances

Eq v => DivisionBasis (NonComMonomial v) Source |

ncm :: [v] -> NonComMonomial v Source

lm :: Vect t t1 -> t1 Source

lc :: Vect t t1 -> t Source

lt :: Vect k b -> Vect k b Source

quotRemNP :: (Eq t, Fractional t, Ord m, Show m, Algebra t m, DivisionBasis m) => Vect t m -> [Vect t m] -> ([(Vect t m, Vect t m)], Vect t m) Source

remNP :: (Eq t, Fractional t, Ord m, Show m, Algebra t m, DivisionBasis m) => Vect t m -> [Vect t m] -> Vect t m Source

(%%) :: (Eq t, Fractional t, Ord m, Show m, Algebra t m, DivisionBasis m) => Vect t m -> [Vect t m] -> Vect t m infixl 7 Source